/*
 GB USB Keyboard
 Version: 1.0
 Author: Alex from insideGadgets (http://www.insidegadgets.com)
 Created: 29/01/2021
 Last Modified: 15/03/2021
 
 */

#include <stdio.h>
#include <gb/gb.h>
#include <gb/console.h>
#include <gb/drawing.h>

void init();
void options();
void checkInput();
void timer_isr();
WORD senddata(WORD);
WORD sleep();
WORD receivedata(WORD);

UWORD textx = 0;
UWORD texty = 3;

void main() {
	DISPLAY_ON;
	printf("   insideGadgets\n USB Keyboard Test\n\n");
	
	while (1) {
		sleep();
		checkInput();
	}
}

void checkInput() {
	WORD dataReceived = 0;
	UBYTE textinc = 0;
	
	senddata(0); // Send anything via the link cable (won't be processed)
	delay(5); // Delay a little bit for the transfer to happen
	dataReceived = receivedata(0); // Read the received data
	
	// Process data, convert numbers received to a readable format
	if (dataReceived >= 1 && dataReceived < 254) {
		if (dataReceived == 137) {
			printf(" ");
			textinc = 1;
		}
		else if (dataReceived == 148) {
			printf(".");
			textinc = 1;
		}
		else if (dataReceived == 145) {
			printf("'");
			textinc = 1;
		}
		else if (dataReceived == 147) {
			printf(",");
			textinc = 1;
		}
		else if (dataReceived == 133) { // Enter
			printf("\n");
			texty++;
			textx = 0;
		}
		else if (dataReceived == 135) { // Backspace
			textx--;
			gotoxy(textx, texty);
			printf(" ");
			gotoxy(textx, texty);
			if (textx == 0) {
				textx = 20;
				texty--;
			}
		}
		else if (dataReceived == 132) { // 0
			printf("0");
			textinc = 1;
		}
		else if (dataReceived >= 123 && dataReceived <= 132) { // Numbers
			printf("%c", (UWORD) dataReceived - 74);
			textinc = 1;
		}
		else { // Anything else, display it
			printf("%c", (UWORD) dataReceived);
			
			// Or print the number
			//printf("%d", (UWORD) dataReceived);
			textinc = 1;
		}
		
		if (textinc == 1) {
			textinc = 0;
			textx++;
			if (textx == 20) {
				textx = 0;
				texty++;
			}
		}
	}
}

void timer_isr(void) { }
